import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;

public class NaiveBayes {
	public int NV; //Number of Variables.
	public int CrossValidation; //How many times split data for cross validation.
	public ArrayList<int[]> RD; //Read data
	public ArrayList<ArrayList<Integer>> structure;

	public NaiveBayes(String path_to_dataset, String path_to_directory_for_output, int cv) throws IOException{
		System.out.print("Exeute GBN-BDeu with ");
		System.out.println(cv + "-fold cross-validation.");
		CrossValidation = cv;
		readNV(path_to_dataset);
		structure = new ArrayList<>();
		for(int i = 0; i < NV; ++i){
			structure.add(new ArrayList<>());
			if(i != NV - 1){
				structure.get(i).add(NV - 1);
			}
		}
		for(int j = 0; j < CrossValidation; ++j){
			System.out.print("Executing for cross validation "+(j+1));
			writeStructure(path_to_directory_for_output, j);
			System.out.println("; Complete.");
		}
	}

	protected void readNV(String DataBaseName) throws IOException{
		BufferedReader br = new BufferedReader(new FileReader(new File(DataBaseName)));
		ArrayList<String[]> tRD = new ArrayList<String[]>();
		String line = br.readLine();
		NV = line.split(",").length;
		br.close();
	}

	public void writeStructure(String path, int j){
		try{
			File outputDir = new File(path);
			if (outputDir.exists()){
				File file = new File(path + "/" + (j+1) + ".txt");
				file.createNewFile();
				PrintWriter pw = new PrintWriter(new BufferedWriter(new FileWriter(file)));
				for(int i = 0; i < NV; ++i){
					pw.print(i);
					pw.print("\t");
				}
				pw.println();
				for(int i = 0; i < NV; ++i){
					ArrayList<Integer> t = structure.get(i);
					if(t.size() != 0){
						pw.print(t.get(0));
						for(int p = 1; p < t.size(); ++p){
							pw.print(",");
							pw.print(t.get(p));
						}
					}else{
						pw.print(-1);
					}
					pw.print("\t");
				}
				pw.close();
			}else{
				System.out.println();
				System.out.println("The output directory not found.");
				System.exit(0);
			}
		}catch(IOException e){
			System.out.println(e);
		}
	}
}
