import java.math.BigInteger;
import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.HashMap;
import java.util.PriorityQueue;

public class getBestNets {
	public int NV; //Number of Variables.
	public int[] NC; //NC[i] : the i-th variable configures.
	public int MNC; // max{NC[i]}
	public ArrayList<Double[]> LS;
	public ArrayList<ArrayList<ArrayList<Integer>>> BP;
	private ArrayList<ArrayList<ArrayList<double[]>>> BPwithLS;
	private ArrayList<ArrayList<AbstractMap.SimpleEntry<HashMap<Integer, ArrayList<Integer>>, Double>>> BN;
	private int fANB;
	public ArrayList<ArrayList<Integer>> learnedStructure;

	public getBestNets(int fANB, int nv, int[] nc, int mnc, ArrayList<Double[]> ls, ArrayList<ArrayList<ArrayList<Integer>>> bp){
		this.fANB = fANB;
		NV = nv;
		NC = nc;
		MNC = mnc;
		LS = ls;
		BP = bp;
		initBPwithLS();
		initBN();
		for(int n = 1; n <= NV - fANB; ++n){
			setAllBestNets(NV - fANB, n, 0, 0);
		}
		learnedStructure = getStructure();
	}

	private void initBPwithLS(){
		BPwithLS = new ArrayList<>();
		for(int i = 0; i < NV - fANB; ++i){
			ArrayList<ArrayList<double[]>> t = new ArrayList<ArrayList<double[]>>();
			for(int j = 0; j < (1 << (NV - fANB - 1)); ++j){
				t.add(new ArrayList<double[]>());
			}
			BPwithLS.add(t);
			t = null;
		}

		for(int i = 0; i < NV - fANB; ++i){
			for(int j = 0; j < (1 << (NV - fANB - 1)); ++j){
				double[] t = new double[2];
				t[0] = BP.get(i).get(j).get(0);
				t[1] = LS.get(i)[(int) t[0]];
				BPwithLS.get(i).get(j).add(t);
			}
		}
	}

	private void initBN(){
		BN = new ArrayList<>();
		for(int j = 0; j < (1 << (NV - fANB)); ++j){
			BN.add(new ArrayList<AbstractMap.SimpleEntry<HashMap<Integer, ArrayList<Integer>>, Double>>());
		}
		AbstractMap.SimpleEntry<HashMap<Integer, ArrayList<Integer>>, Double>
		t = new AbstractMap.SimpleEntry<HashMap<Integer, ArrayList<Integer>>, Double>
		(new HashMap<Integer, ArrayList<Integer>>(), 0.0);
		BN.get(0).add(t);
	}

	private void setAllBestNets(int size, int n, int j, int k){
		if(n <= 0){
			setBestNets(j);
		}else{
			for(int i = 0; i < size - (n - 1); ++i){
				setAllBestNets(size-(i+1), n-1, j + (1 << (k+i)), k+i+1);
			}
		}
	}

	private void setBestNets(int j){
		PriorityQueue<double[]> pq = new PriorityQueue<>(10, AAA);
		for(int i = 0; i < NV - fANB; ++i){
			if((j & (1 << i)) > 0){
				int m = encode(i, j);
				int n = j - (1 << i);
				for(int k1 = 0; k1 < BPwithLS.get(i).get(m).size(); ++k1){
					for(int k2 = 0; k2 < BN.get(n).size(); ++k2){
						double[] element = new double[4];
						element[0] = (double)i; element[1] = (double)k1; element[2] = (double)k2;
						element[3] = BPwithLS.get(i).get(m).get(k1)[1] + BN.get(n).get(k2).getValue();
						pq.add(element);
						element = null;
					}
				}
			}
		}
		if(BN.get(j).isEmpty()){
			double[] t = pq.poll();
			int i = (int)t[0];
			int k1 = (int)t[1];
			int k2 = (int)t[2];
			double value = t[3];
			t = null;
			int m = encode(i, j);
			int n = j - (1 << i);
			int p = (int)BPwithLS.get(i).get(m).get(k1)[0];
			ArrayList<Integer> parent = new ArrayList<>();
			for(int c = 0; c < i; ++c) if((p & (1 << c)) > 0) parent.add(c);
			for(int c = i; c < NV - fANB - 1; ++c) if((p & (1 << c)) > 0) parent.add(c+1);
			HashMap<Integer, ArrayList<Integer>> network = new HashMap(BN.get(n).get(k2).getKey());
			network.put(i, parent);
			BN.get(j).add(new AbstractMap.SimpleEntry<>(network, value));
		}
	}

	public ArrayList<ArrayList<Integer>> getStructure(){
		ArrayList<ArrayList<Integer>> structure = new ArrayList();
		for(int i = 0; i < NV - fANB; ++i){
			structure.add(new ArrayList());
			ArrayList<Integer> t = BN.get((int)Math.pow(2, NV - fANB) - 1).get(0).getKey().get(i);
			for(int p = 0; p < t.size(); ++p){
				structure.get(i).add(t.get(p));
			}
			if(fANB == 1){
				structure.get(i).add(NV - 1);
			}
		}
		if(fANB == 1){
			structure.add(new ArrayList());
		}
		return structure;
	}

	public Comparator<double[]> AAA = new Comparator<double[]>() {
		@Override
		public int compare(double[] a, double[] b) {
			if(a[3] - b[3] > 0){
				return -1;
			}else{
				return 1;
			}
		}
	};

	private int encode(int i, int j){
		int down = j % (1 << i);
		int up = j / (1 << (i+1));
		return up*(1 << i) + down;
	}

	public BigInteger product(int a, int b){// a^b
		BigInteger r = BigInteger.ONE;
		for(int i = 0; i < b; ++i){
			r = r.multiply(BigInteger.valueOf(a));
		}
		return r;
	}
}
