import java.util.ArrayList;
import java.util.Comparator;
import java.util.PriorityQueue;

public class getBestParents {

	public int NV; //Number of Variables.
	public int[] NC; //NC[i] : the i-th variable configures.
	public int MNC; // max{NC[i]}
	public ArrayList<Double[]> LS;
	public ArrayList<ArrayList<ArrayList<Integer>>> BP;
	private int I;
	private int fANB;

	public getBestParents(int fANB, int nv, int[] nc, int mnc, ArrayList<Double[]> ls, boolean tan){
		this.fANB = fANB;
		NV = nv;
		NC = nc;
		MNC = mnc;
		LS = ls;
		initBP();
		if(tan){
			setBestParents_TAN();
		}else{
			setBestParents();
		}
	}

	private void initBP(){
		BP = new ArrayList<>();
		for(int i = 0; i < NV - fANB; ++i){
			ArrayList<ArrayList<Integer>> t = new ArrayList<ArrayList<Integer>>();
			for(int j = 0; j < Math.pow(2, NV - fANB - 1); ++j){
				t.add(new ArrayList<Integer>());
			}
			BP.add(t);
		}
	}

	private void setBestParents(){
		PriorityQueue<int[]> pq = new PriorityQueue<>(10, CCC);
		for(int i = 0; i < NV - fANB; ++i){
			I = i;
			for(int j = 0; j < Math.pow(2, NV - fANB - 1); ++j){
				for(int c = 0; c < NV - fANB - 1; ++c){
					if((j & (1 << c)) > 0){
						int n = j - (1 << c);
						for(int k = 0; k < BP.get(i).get(n).size(); ++k){
							int[] t = new int[2];
							t[0] = n;
							t[1] = k;
							pq.add(t);
							t = null;
						}
					}
				}
				if(pq.size() < 1){
					BP.get(i).get(j).add(j);
				}else{
					boolean flag = false;
					for(int m = 0; m < 1; ++m){
						int[] t = pq.poll();
						int selection = BP.get(i).get(t[0]).get(t[1]);
						if( (LS.get(i)[j] > LS.get(i)[selection])  && !flag){
							BP.get(i).get(j).add(j);
							pq.add(t);
							flag = true;
						}else{
							BP.get(i).get(j).add(selection);
						}
					}
				}
				pq.clear();
			}
		}
	}

	private void setBestParents_TAN(){
		PriorityQueue<int[]> pq = new PriorityQueue<>(10, CCC);
		for(int i = 0; i < NV - fANB; ++i){
			I = i;
			for(int j = 0; j < Math.pow(2, NV - fANB - 1); ++j){
				int num = fANB;
				for(int c = 0; c < NV - fANB - 1; ++c){
					num += (j >> c) & 1;
				}
				for(int c = 0; c < NV - fANB - 1; ++c){
					if((j & (1 << c)) > 0){
						int n = j - (1 << c);
						for(int k = 0; k < BP.get(i).get(n).size(); ++k){
							int[] t = new int[2];
							t[0] = n;
							t[1] = k;
							pq.add(t);
							t = null;
						}
					}
				}
				if(pq.size() < 1){
					BP.get(i).get(j).add(j);
				}else{
					int[] t = pq.poll();
					int selection = BP.get(i).get(t[0]).get(t[1]);

					if(num == 2){
						BP.get(i).get(j).add(j);
					}
					else if((num < 2) && (LS.get(i)[j] > LS.get(i)[selection])){
						BP.get(i).get(j).add(j);
					}else{
						BP.get(i).get(j).add(selection);
					}

				}
				pq.clear();
			}
		}
	}

	public Comparator<int[]> CCC = new Comparator<int[]>() {
		@Override
		public int compare(int[] a, int[] b) {
			if(LS.get(I)[BP.get(I).get(a[0]).get(a[1])] - LS.get(I)[BP.get(I).get(b[0]).get(b[1])] > 0){
				return -1;
			}else{
				return 1;
			}
		}
	};
}
